        .text
        .align  3
        .globl  gUSA_test_and_set
        .ent    gUSA_test_and_set
        .set    noreorder
gUSA_test_and_set:
        li      $3, -1
        la      $8, 1f
        move    $9, $sp
        li      $sp, -8         # critical region start: rewind point #1
   0:   lw      $2, ($4)        # rewind point #2
        sw      $3, ($4)
   1:   move    $sp, $9         # critical region end
        j       $31
        nop
        .end    gUSA_test_and_set


static int
gUSA_exchange_and_add (volatile int *mem, int val)
{
  unsigned long dummy;
  int result;

  __asm__ (".align 2\n\t"
       "la      $8, 1f\n\t"
       "move    $9, $sp\n\t"
       "li      $sp, -16        # critical region start: rewind point #1\n"
   "0:  lw      %0, (%2)        # rewind point #2\n\t"
       "move    %1, %3\n\t"
       "addu    %1, %0, %1\n\t"
       "sw      %1, (%2)\n"
   "1:  move    $sp, $9         # critical region end"
           : "=&r" (result), "=&r" (dummy)
           : "r" (mem), "r" (val)
           : "memory", "$8", "$9");

  return result;
}
